/****************************************************************************
 * OPENDATA.H                                                               *
 *                                                                          *
 *  This header file contains the definition of the data structure used     *
 *  to hold static data for the open file and find file dialog boxes.       *
 *                                                                          *
 *  Modifications --                                                        *
 *      21-Sep-1989 : Initial version.                                      *
 *                                                                          *
 * (c)Copyright 1989 Rick Yoder                                             *
 ****************************************************************************/

    typedef struct {
        PSZ     pszTitle;           // dialog box title
        PSZ     pszIns;             // dialog box instructions
        void (CALLBACK *pfnHelpProc)(HWND hDlg); // ptr to help procedure
        PSZ     pszFile;            // ptr to name of opened file
        PHFILE  phf;                // ptr to file handle
        ULONG   ulFileSize;         // initial file size
        PUSHORT pusAction;          // action taken on open
        USHORT  usAttribute;        // file attribute
        USHORT  fsOpenFlags;        // open flags
        USHORT  fsOpenMode;         // open mode
        ULONG   ulReserved;         // reserved
        PSZ     pszShowSpec;        // file spec of files to be listed
        USHORT  usShowAttr;         // attributes of files to be listed
        USHORT  usMaxPathLen;       // maximum path name length
        PSZ     pszScratch;         // ptr to scratch data area
        HMODULE hmod;               // handle to resource module
        USHORT  usSelectDrive;      // current selected item in drive list box
        USHORT  usSelectDir;        // current selected item in dir list box
        USHORT  usSelectFile;       // current selected item in file list box
        USHORT  usSelectFind;       // current selected item in find list box
        USHORT  usFocus;            // control to which focus is to be returned
                                    //  after an unsuccesful open attempt.
        } DATA;

    typedef DATA * PDATA;
